﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;

namespace TestPanelGradient
{
    public partial class Form1 : Form
    {
        int animationNumber = 0;

        public Form1()
        {
            InitializeComponent();

            //timer_text.Start();

            label1.Hide();

            //roundPanel_left.Opcity = 0;
            //roundPanel_title.Opcity = 0;
            roundPanel_left.Opcity = 255;
            roundPanel_title.Opcity = 255;
            roundPanel_tab0.Opcity = 255;
            roundPanel_tab1.Opcity = 255;

            DateTime dt = DateTime.Now;
            label_text.Text =
                (dt.Hour + ":" + dt.Minute + ":" + dt.Second + ":" + dt.Millisecond).ToString();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics graphics = e.Graphics;
            
            using (Brush brush = new LinearGradientBrush(
                            new Rectangle(0, 0, this.ClientRectangle.Width, this.ClientRectangle.Height),
                            Color.FromArgb(234, 234, 234),
                            Color.FromArgb(204, 204, 204),
                            90.0f))
            {
                graphics.FillRectangle(brush, 0, 0, this.ClientRectangle.Width, this.ClientRectangle.Height);
            }
        }

        private void roundPanel_title_Paint(object sender, PaintEventArgs e)
        {
            RoundPanel panel = (RoundPanel)sender;

            Graphics g = e.Graphics;
            g.SmoothingMode = SmoothingMode.HighQuality;

            int width = panel.ClientRectangle.Width;
            int height = panel.ClientRectangle.Height;

            Rectangle rect = new Rectangle(0, 0, width-1, height-1);
            using (GraphicsPath path = RoundPanel.GetRoundedRectPath(rect, 8))
            {
                using (Brush brush = new LinearGradientBrush(
                                            new Rectangle(0, 0, panel.ClientRectangle.Width, panel.ClientRectangle.Height),
                                            Color.FromArgb(panel.Opcity, 102, 102, 102),
                                            Color.FromArgb(panel.Opcity, 0, 0, 0),
                                            90.0f))
                {
                    //graphics.FillRectangle(brush, 0, 0, this.ClientRectangle.Width, this.ClientRectangle.Height);
                    g.FillPath(brush, path);
                }

                //g.FillPath(Brushes.Yellow, path);
                Pen pen = new Pen(Color.FromArgb(panel.Opcity, 255, 255, 255));
                g.DrawPath(pen, path);
            }
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            timer_animation.Stop();
            timer_animation.Start();
        }

        private void timer_animation_Tick(object sender, EventArgs e)
        {
            if (animationNumber == 0)
            {
                roundPanel_title.Opcity += 10;
                if (roundPanel_title.Opcity > 255)
                {
                    roundPanel_title.Opcity = 255;
                    animationNumber = 1;
                }

                roundPanel_title.Invalidate();
            }
            else if (animationNumber == 1)
            {
                roundPanel_left.Opcity += 10;
                if (roundPanel_left.Opcity > 255)
                {
                    roundPanel_left.Opcity = 255;
                    animationNumber = 2;
                }

                roundPanel_left.Invalidate();
            }
            else
            {
                //roundPanel_title.Opcity = 0;
                //roundPanel_left.Opcity = 0;
                //animationNumber = 0;

                timer_animation.Stop();
                timer_stop.Start();
            }

            //roundPanel_title.Invalidate();
            //roundPanel_left.Invalidate();
        }

        private void roundPanel_left_Paint(object sender, PaintEventArgs e)
        {
            RoundPanel panel = (RoundPanel)sender;

            Graphics g = e.Graphics;
            g.SmoothingMode = SmoothingMode.HighQuality;

            int width = panel.ClientRectangle.Width;
            int height = panel.ClientRectangle.Height;

            Rectangle rect = new Rectangle(0, 0, width - 1, height - 1);
            using (GraphicsPath path = RoundPanel.GetRoundedRectPath(rect, 8))
            {
                using (Brush brush = new LinearGradientBrush(
                                            new Rectangle(0, 0, panel.ClientRectangle.Width, panel.ClientRectangle.Height),
                                            Color.FromArgb(panel.Opcity, 200, 200, 200),
                                            Color.FromArgb(panel.Opcity, 210, 210, 210),
                                            0.0f))
                {
                    //graphics.FillRectangle(brush, 0, 0, this.ClientRectangle.Width, this.ClientRectangle.Height);
                    g.FillPath(brush, path);
                }

                //g.FillPath(Brushes.Yellow, path);
                Pen pen = new Pen(Color.FromArgb(panel.Opcity, 255, 255, 255));
                g.DrawPath(pen, path);
            }
        }

        private void timer_animation2_Tick(object sender, EventArgs e)
        {
            timer_animation2.Stop();
            timer_animation.Start();
        }

        private void timer_stop_Tick(object sender, EventArgs e)
        {
            roundPanel_title.Opcity = 0;
            roundPanel_left.Opcity = 0;
            animationNumber = 0;

            roundPanel_title.Invalidate();
            roundPanel_left.Invalidate();

            timer_stop.Stop();
            timer_animation2.Start();
        }

        private void Form1_ResizeEnd(object sender, EventArgs e)
        {
            //Invalidate();
        }

        private void Form1_SizeChanged(object sender, EventArgs e)
        {
            Invalidate();
        }

        private void roundPanel_tab0_Paint(object sender, PaintEventArgs e)
        {
            RoundPanel panel = (RoundPanel)sender;

            Graphics g = e.Graphics;
            g.SmoothingMode = SmoothingMode.HighQuality;

            int width = panel.ClientRectangle.Width;
            int height = panel.ClientRectangle.Height;

            Rectangle rect = new Rectangle(0, 0, width - 1, height - 1);
            using (GraphicsPath path = RoundPanel.GetRoundedRectPath(rect, 8))
            {
                using (Brush brush = new LinearGradientBrush(
                                            new Rectangle(0, 0, panel.ClientRectangle.Width, panel.ClientRectangle.Height),
                                            Color.FromArgb(panel.Opcity, 100, 150, 150),
                                            Color.FromArgb(panel.Opcity, 120, 170, 170),
                                            90.0f))
                {
                    //graphics.FillRectangle(brush, 0, 0, this.ClientRectangle.Width, this.ClientRectangle.Height);
                    g.FillPath(brush, path);
                }

                //g.FillPath(Brushes.Yellow, path);
                Pen pen = new Pen(Color.FromArgb(panel.Opcity, 255, 255, 255));
                g.DrawPath(pen, path);
            }
        }

        private void roundPanel_tab1_Paint(object sender, PaintEventArgs e)
        {
            RoundPanel panel = (RoundPanel)sender;

            Graphics g = e.Graphics;
            g.SmoothingMode = SmoothingMode.HighQuality;

            int width = panel.ClientRectangle.Width;
            int height = panel.ClientRectangle.Height;

            Rectangle rect = new Rectangle(0, 0, width - 1, height - 1);
            using (GraphicsPath path = RoundPanel.GetRoundedRectPath(rect, 8))
            {
                using (Brush brush = new LinearGradientBrush(
                                            new Rectangle(0, 0, panel.ClientRectangle.Width, panel.ClientRectangle.Height),
                                            Color.FromArgb(panel.Opcity, 150, 100, 150),
                                            Color.FromArgb(panel.Opcity, 170, 120, 170),
                                            90.0f))
                {
                    //graphics.FillRectangle(brush, 0, 0, this.ClientRectangle.Width, this.ClientRectangle.Height);
                    g.FillPath(brush, path);
                }

                //g.FillPath(Brushes.Yellow, path);
                Pen pen = new Pen(Color.FromArgb(panel.Opcity, 255, 255, 255));
                g.DrawPath(pen, path);
            }

        }

        private void timer_text_Tick(object sender, EventArgs e)
        {
            DateTime dt = DateTime.Now;
            label_text.Text = 
                (dt.Hour + ":" + dt.Minute + ":" + dt.Second + ":" + dt.Millisecond).ToString();
        }
    }
}
