﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace TestPanelGradient
{
    public partial class UserControl1 : UserControl
    {
        private bool bLoopDir = true;

        public UserControl1()
        {
            InitializeComponent();

            this.SetStyle(ControlStyles.UserPaint |
                            ControlStyles.AllPaintingInWmPaint |
                            ControlStyles.DoubleBuffer, true);

            roundPanel_main.Opcity = 255;
        }

        private void roundPanel_main_Paint(object sender, PaintEventArgs e)
        {
            RoundPanel panel = (RoundPanel)sender;

            Graphics g = e.Graphics;
            g.SmoothingMode = SmoothingMode.HighQuality;

            int width = panel.ClientRectangle.Width;
            int height = panel.ClientRectangle.Height;

            Rectangle rect = new Rectangle(0, 0, width - 1, height - 1);
            using (GraphicsPath path = RoundPanel.GetRoundedRectPath(rect, 8))
            {
                using (Brush brush = new LinearGradientBrush(
                                            new Rectangle(0, 0, panel.ClientRectangle.Width, panel.ClientRectangle.Height),
                                            Color.FromArgb(panel.Opcity, 200, 150, 150),
                                            Color.FromArgb(panel.Opcity, 170, 170, 170),
                                            90.0f))
                {
                    //graphics.FillRectangle(brush, 0, 0, this.ClientRectangle.Width, this.ClientRectangle.Height);
                    g.FillPath(brush, path);
                }

                //g.FillPath(Brushes.Yellow, path);
                Pen pen = new Pen(Color.FromArgb(panel.Opcity, 255, 255, 255));
                g.DrawPath(pen, path);
            }
        }

        private void timer_main_Tick(object sender, EventArgs e)
        {
            if (bLoopDir)
            {
                this.roundPanel_main.Opcity -= 10;
                if (this.roundPanel_main.Opcity < 0)
                {
                    this.roundPanel_main.Opcity = 0;
                    bLoopDir = false;
                }
            }
            else
            {
                this.roundPanel_main.Opcity += 10;
                if (this.roundPanel_main.Opcity > 255)
                {
                    this.roundPanel_main.Opcity = 255;
                    bLoopDir = true;
                }
            }

            this.roundPanel_main.Invalidate();
        }
    }
}
